summaryrefslogtreecommitdiff
path: root/t/t5318-commit-graph.sh
diff options
context:
space:
mode:
authorLibravatar Taylor Blau <me@ttaylorr.com>2020-04-14 22:31:37 -0600
committerLibravatar Junio C Hamano <gitster@pobox.com>2020-04-15 09:20:34 -0700
commit7a9ce0269bc0f4ef230f930b3910b70ac3142552 (patch)
treee135caeef62e7d138d2e9aee337b25a6de1fec36 /t/t5318-commit-graph.sh
parentcommit-graph.h: replace 'commit_hex' with 'commits' (diff)
downloadtgif-7a9ce0269bc0f4ef230f930b3910b70ac3142552.tar.xz
commit-graph.c: introduce '--[no-]check-oids'
When operating on a stream of commit OIDs on stdin, 'git commit-graph write' checks that each OID refers to an object that is indeed a commit. This is convenient to make sure that the given input is well-formed, but can sometimes be undesirable. For example, server operators may wish to feed the refnames that were updated during a push to 'git commit-graph write --input=stdin-commits', and silently discard refs that don't point at commits. This can be done by combing the output of 'git for-each-ref' with '--format %(*objecttype)', but this requires opening up a potentially large number of objects. Instead, it is more convenient to feed the updated refs to the commit-graph machinery, and let it throw out refs that don't point to commits. Introduce '--[no-]check-oids' to make such a behavior possible. With '--check-oids' (the default behavior to retain backwards compatibility), 'git commit-graph write' will barf on a non-commit line in its input. With 'no-check-oids', such lines will be silently ignored, making the above possible by specifying this option. No matter which is supplied, 'git commit-graph write' retains the behavior from the previous commit of rejecting non-OID inputs like "HEAD" and "refs/heads/foo" as before. Signed-off-by: Taylor Blau <me@ttaylorr.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 't/t5318-commit-graph.sh')
-rwxr-xr-xt/t5318-commit-graph.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/t/t5318-commit-graph.sh b/t/t5318-commit-graph.sh
index 69599cea7f..23c7b7e036 100755
--- a/t/t5318-commit-graph.sh
+++ b/t/t5318-commit-graph.sh
@@ -49,6 +49,34 @@ test_expect_success 'exit with correct error on bad input to --stdin-commits' '
test_i18ngrep "invalid commit object id" stderr
'
+graph_expect_commits() {
+ test-tool read-graph >got
+ if ! grep "num_commits: $1" got
+ then
+ echo "graph_expect_commits: expected $1 commit(s), got:"
+ cat got
+ false
+ fi
+}
+
+test_expect_success 'ignores non-commit OIDs to --input=stdin-commits with --no-check-oids' '
+ test_when_finished rm -rf "$objdir/info/commit-graph" &&
+ cd "$TRASH_DIRECTORY/full" &&
+ # write a graph to ensure layers are/are not added appropriately
+ git rev-parse HEAD~1 >base &&
+ git commit-graph write --stdin-commits <base &&
+ graph_expect_commits 2 &&
+ # bad input is rejected
+ echo HEAD >bad &&
+ test_expect_code 1 git commit-graph write --stdin-commits <bad 2>err &&
+ test_i18ngrep "unexpected non-hex object ID: HEAD" err &&
+ graph_expect_commits 2 &&
+ # update with valid commit OID, ignore tree OID
+ git rev-parse HEAD HEAD^{tree} >in &&
+ git commit-graph write --stdin-commits --no-check-oids <in &&
+ graph_expect_commits 3
+'
+
graph_git_two_modes() {
git -c core.commitGraph=true $1 >output
git -c core.commitGraph=false $1 >expect